#include <iostream>

template <class D> class container {
    public:
        container *proximo;
        D elemento;
};


template <class T, class Container=container<T>>
class Fila {
    public:
        void enfilera(T elem) {
            auto cont = new container<T>();
            cont->elemento = elem;

            if (fim != nullptr)
                fim->proximo = cont;
                
            else 
                inicio = cont;
            
            fim = cont;
        }


        T desenfilera() {
            if (inicio != nullptr) {
                T elemento = inicio->elemento;
                Container *i = inicio;
                inicio = inicio->proximo;
                if (inicio == nullptr)
                    fim = nullptr;
                delete i;
                return elemento;
            }
            else
                return -1;
        }

        T frente() {
            if (inicio != nullptr)
                return inicio->elemento;
            else
                return -1;
        }
        
    private:
        Container *inicio = nullptr;
        Container *fim = nullptr;

};

template <class T>
class Pilha { 

    public:
        void empilha(T elemento) {
            N++;
            elementos[N -1] = elemento;

        }
        T desempilha() {
            if (N > 0) {
                N--;
                return elementos[N];
            }
            else
                return -1;
        }

        T topo() {
            if (N > 0)
                return elementos[N -1];
            else   
                return -1;
        }
    private:
        static const int MAX = 900;
        int N = 0;
        T elementos[MAX];

};

template <class T> Fila<T> inverterFila(Fila<T> fila) {

    Fila<T> filaAux;
    while (fila.frente() != -1) {
        filaAux.enfilera(fila.desenfilera());
    }

    return filaAux;
}

template <class T> Fila<T> inverterFilaComPilha(Fila<T> fila) {

    Pilha<T> pilha;
    while (fila.frente() != -1) {
        pilha.empilha(fila.desenfilera());
    }

    printarPilha(pilha, "Fila invertida com Pilha");


    return fila;
}

template <class T> Pilha<T> inverterPilhaComDuasPilhas(Pilha<T> pilha) {

    Pilha<T> pilhaAux, pilhaAux2;
    while (pilha.topo() != -1) {
        pilhaAux.empilha(pilha.desempilha());
    }
    while (pilhaAux.topo() != -1) {
        pilhaAux2.empilha(pilhaAux.desempilha());
    }
    while (pilhaAux2.topo() != -1) {
        pilhaAux.empilha(pilhaAux2.desempilha());
    }

    return pilhaAux;
}

void preencherFila(Fila<char> &fila) {

    fila.enfilera('a');
    fila.enfilera('b');
    fila.enfilera('c');
    fila.enfilera('d');
    fila.enfilera('e');
    fila.enfilera('f');
    fila.enfilera('g');
    fila.enfilera('h');
    fila.enfilera('i');
    fila.enfilera('j');
    fila.enfilera('k');
    fila.enfilera('l');
    fila.enfilera('m');
    fila.enfilera('n');
    fila.enfilera('o');
    fila.enfilera('p');
    fila.enfilera('q');
    fila.enfilera('r');
    fila.enfilera('s');
    fila.enfilera('t');
    fila.enfilera('u');
    fila.enfilera('v');
    fila.enfilera('w');
    fila.enfilera('x');
    fila.enfilera('y');
    fila.enfilera('z');
}

void printarFila(Fila<char> &fila, std::string texto) {

    std::cout << "----" << texto << "------" << std::endl;
    while (fila.frente() != -1) {
        std::cout << "| " << fila.desenfilera() << " " ;
    }
    std::cout << "|" << std::endl;
}

void printarPilha(Pilha<char> &pilha, std::string texto) {

    std::cout << "----" << texto << "------" << std::endl;
    while (pilha.topo() != -1) {
        std::cout << "| " << pilha.desempilha() << " " ;
    }
    std::cout << "|" << std::endl;
}

int main(int argc, char* argv[]) {

    Fila<char> fila;
    preencherFila(fila);
    printarFila(fila, "Fila normal");

    

    preencherFila(fila);
    fila = inverterFila(fila);
    printarFila(fila, "Fila invertida com outra fila ???");

    preencherFila(fila);
    inverterFilaComPilha(fila);
    //printarFila(fila, "Fila invertida com Pilha");
/*
    reencherFila(fila);
    pilha = inverterPilhaComFila(pilha);
    printarFila(fila, "Fila normal");

    reencherFila(fila);
    pilha = inverterPilhaComDuasPilhas(pilha);
    printarFila(fila, "Fila normal");*/
    

    
    return 0;
}